#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <vector>
#include <sockinet.h>

class Point;
class Package;
class PackageList;
class Robot;
class Robots;
class Message;
class Game;
class SparseArray;
class MoveList;
class Move;

enum MoveType {NORTH = 'N', SOUTH = 'S', EAST = 'E', WEST = 'W', PICK = 'P', DROP = 'D', POS = 'X', NOOP = ' ', DELIVER='!', GATHER='G'};
enum TileType {PLAIN = '.', WATER = '~', WALL = '#', BASE = '@'};
typedef vector<Package *> Packages;
typedef SparseArray Map;
typedef iosockinet IO;
typedef long Score;
typedef long Weight;
typedef long Money;
typedef long ID;
typedef unsigned int Index;
typedef unsigned long Distance;
typedef int Coordinate;
typedef vector<Move *>	Moves;
typedef long Goodness;
#endif
