#include <iostream.h>
#include "PathFinder.h"

int AS_Valid (_asNode * parent, _asNode * node, int data, void * pointer) 
{
	cout << "AS_Valid called : (" << parent->x << "," << parent->y << ") -" <<
			node->x << "," << node->y << ")" << endl;

	if ((node->x >= 1) && (node->x <= 4) && (node->y >= 1) && (node->y <= 4))
			return (int) true;
	return (int) false;
}

int AS_Cost (_asNode * parent, _asNode *node, int data, void *pointer)
{
		//if ((node->x == 2) && (node->y == 2)) 
		//		return (4);
		return (2);
}

void main() {
		CAStar star;

		star.Reset();
		star.SetRows (4);
		star.udValid = AS_Valid;
		star.udCost = AS_Cost;
		star.udNotifyList = NULL;
		star.udNotifyChild = NULL;
		star.m_pCBData = (void *)NULL;
		star.m_pNCData = (void *)NULL;
		if (star.GeneratePath (1,1,4,4)) {
				cout << "GeneratePath == true" << endl;
		}

		_asNode * best = star.GetBestNode();
		while (best != NULL) {
			cout << best->x << " " << best->y << endl;
			best = best->parent;
		}
}
